Subject: Re: [Rtg-ooam-dt] draft-brockners-inband-oam-data

From: Gregory Mirsky <[email-masked]>
Date: Sat, 23 Jul 2016 06:05:33 +0000

Hi Deepak,
though, and I agree, flexibility of formats is beneficial it bears cost in fast path processing. There is continued discussion on NVO3 list that I'm sure you're following. And that is where input from David, Tal and other NPU vendors is most helpful (I took liberty to our DT to the discussion).As for applicability of Active OAM and iOAM, I personally don't see them being used on the same packet. Active OAM can share the path and QoS handling with the data flow it intended to monitor and all functionality of iOAM can be carried by the Active OAM. At the same time, I see good reason to make TLVs re-usable between iOAM and Active OAM.

                Regards,
                                Greg

From: Deepak Kumar (dekumar) [mailto:[email-masked]]
Sent: Friday, July 22, 2016 11:26 PM
To: Gregory Mirsky <[email-masked]>; [email-masked]
Cc: Carlos Pignataro (cpignata) <[email-masked]>; Nagendra Kumar Nainar (naikumar) <[email-masked]>; David Mozes <[email-masked]>
Subject: Re: draft-brockners-inband-oam-data

Hi Greg,

I believe just I-oam header should be placed flexibly, if network is l2/l3 leaf and traffic is within one data center then current format is fine.
If traffic is going over L2 and L3 vxlan seperated, or Border Leaf, Data Center Interconnect I-oam header can come fixed byte inside data and configuration policy can determine this behavior if required.
Now How to indicate if common OAM header is starting immediately or after Fixed byte, I will left to community.
Using single "O" bit is also fine for active OAM as we can look at two places if we use optional Fixed byte.

As I-OAM is for real data it will be issue and they might not support that mode or getting extra bit in Datapath header will solve this issue.

L2/L3 distributed scenario is currently deployed by operator.

   In-band OAM header in VXLAN GPE header:

    0                   1                   2                   3

    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                    Outer Ethernet Header                      |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                        Outer IP Header                        |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                       Outer UDP Header                        |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   |R|R|Ver|I|P|R|O|          Reserved             | NP = i.b.OAM  |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ GPE

   |     Virtual Network Identifier (VNI)          | Reserved      |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

            Fixed Byte of Inner Packet Real Data (Optional)

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   | Type =i.b.OAM | i.b.OAM HDR len |  Reserved     | NP = IP/Eth |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+iOAM

   |                     in-band OAM options                       |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   |                                                               |

   |                                                               |

   |                     Payload + Padding (L2/L3/ESP/...)         |

   |                                                               |

   |                                                               |

   |                                                               |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Thanks,
Deepak

From: Gregory Mirsky <[email-masked]<mailto:[email-masked]>>
Date: Friday, July 22, 2016 at 2:12 PM
To: dekumar <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Cc: "Carlos Pignataro (cpignata)" <[email-masked]<mailto:[email-masked]>>, "Nagendra Kumar Nainar (naikumar)" <[email-masked]<mailto:[email-masked]>>, David Mozes <[email-masked]<mailto:[email-masked]>>
Subject: RE: draft-brockners-inband-oam-data

Hi Deepak,
should 'i.b.OAM HDR len' be 'i.b.OAM len' so that node that doesn't support iOAM skips over it?

                Regards,
                                Greg

From: Deepak Kumar (dekumar) [mailto:[email-masked]]
Sent: Friday, July 22, 2016 10:45 PM
To: [email-masked]<mailto:[email-masked]>
Cc: Carlos Pignataro (cpignata) <[email-masked]<mailto:[email-masked]>>; Nagendra Kumar Nainar (naikumar) <[email-masked]<mailto:[email-masked]>>; Gregory Mirsky <[email-masked]<mailto:[email-masked]>>; David Mozes <[email-masked]<mailto:[email-masked]>>
Subject: draft-brockners-inband-oam-data

Hi Frank,

For VXLAN-GPE or overlay scenario we can have deployment where L2 and L3 overlay is distributed on multiple devices and in this case host to host traffic is stiched across 2 overlay tunnels.

Below is network example

Super Spine     --- Acting as L3 Overlay
|
|

Spine   --- Underlay
|
|
Leaf   -- Starting L2 Overlay
|
Host

In this scenario inter-subnet traffic for Host attached to leaf will always go to super spine on default tunnel, de-cap, then inner packet is parsed and based on inner packet destination it's put in egress vxlan tunnel and re-encapped.

In this scenario we can't start common oam header right after outer UDP header. We have to put deep inside the packet.

Please see https://tools.ietf.org/html/draft-pang-nvo3-vxlan-path-detection-02  .

   In-band OAM header in VXLAN GPE header:

    0                   1                   2                   3

    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                    Outer Ethernet Header                      |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                        Outer IP Header                        |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   |                       Outer UDP Header                        |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   |R|R|Ver|I|P|R|O|          Reserved             | NP = i.b.OAM  |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ GPE

   |     Virtual Network Identifier (VNI)          | Reserved      |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   | Type =i.b.OAM | i.b.OAM HDR len |  Reserved     | NP = IP/Eth |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+iOAM

   |                     in-band OAM options                       |  |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ +

   |                                                               |

   |                                                               |

   |                     Payload + Padding (L2/L3/ESP/...)         |

   |                                                               |

   |                                                               |

   |                                                               |

   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Thanks,
Deepak